public inbox for linux-kbuild@vger.kernel.org
 help / color / mirror / Atom feed
* [PATCH] kbuild: deb-pkg: require debian_revision when creating source package
@ 2025-03-11 19:00 Masahiro Yamada
  2025-03-21  5:22 ` Nicolas Schier
  0 siblings, 1 reply; 3+ messages in thread
From: Masahiro Yamada @ 2025-03-11 19:00 UTC (permalink / raw)
  To: linux-kbuild
  Cc: linux-kernel, Ben Hutchings, Masahiro Yamada, Nathan Chancellor,
	Nicolas Schier

Debian Policy [1] specifies the version format as follows:

    [epoch:]upstream_version[-debian_revision]

Here, the presence of the debian_revision part indicates a non-native
package, while its absence indicates a native package.

Kbuild adopts the source format 3.0 (quilt), meaning the kernel is a
non-native package and therefore requires the revision portion.

This commit prevents the creation of an invalid source package when
KDEB_PKGVERSION contains no hyphen.

[1]: https://www.debian.org/doc/debian-policy/ch-controlfields.html#version

Signed-off-by: Masahiro Yamada <masahiroy@kernel.org>
---

 scripts/package/mkdebian | 8 ++++++++
 1 file changed, 8 insertions(+)

diff --git a/scripts/package/mkdebian b/scripts/package/mkdebian
index b6dd98ca860b..193e33bcb989 100755
--- a/scripts/package/mkdebian
+++ b/scripts/package/mkdebian
@@ -94,6 +94,14 @@ set_debarch() {
 # Create debian/source/ if it is a source package build
 gen_source ()
 {
+	# The Debian Policy requires -debian_revision portion in the version.
+	# Since the source format 3.0 (quilt) is used here, a hyphen is
+	# required in the version.
+	if [ "${KDEB_PKGVERSION:+set}" ] && ! echo "${KDEB_PKGVERSION}" | grep -- '-..*'; then
+		echo "error: KDEB_PKGVERSION must include a hyphen to create a source package" >&2
+		exit 1
+	fi
+
 	mkdir -p debian/source
 
 	echo "3.0 (quilt)" > debian/source/format
-- 
2.43.0


^ permalink raw reply related	[flat|nested] 3+ messages in thread

end of thread, other threads:[~2025-03-22 14:47 UTC | newest]

Thread overview: 3+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2025-03-11 19:00 [PATCH] kbuild: deb-pkg: require debian_revision when creating source package Masahiro Yamada
2025-03-21  5:22 ` Nicolas Schier
2025-03-22 14:47   ` Masahiro Yamada

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox